"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.removeHyphen = exports.optionsToKeyValue = exports.optionsToDatas = exports.commandsToDatas = void 0;
const metadata_1 = require("../constants/metadata");
const commandsToDatas = (commands = []) => {
    return commands.map(fn => Object.assign(Reflect.getMetadata(metadata_1.metadata.COMMAND_IDENTIFIER, fn), {
        subOptions: Reflect.getMetadata(metadata_1.metadata.SUB_OPTION_IDENTIFIER, fn) || [],
    }));
};
exports.commandsToDatas = commandsToDatas;
const optionsToDatas = (options) => {
    return options.map(fn => Reflect.getMetadata(metadata_1.metadata.OPTION_IDENTIFIER, fn));
};
exports.optionsToDatas = optionsToDatas;
const optionsToKeyValue = (params = []) => {
    if (!params || !params.length)
        return {};
    return params.reduce((pre, current) => {
        const name = `--${current.name}`;
        const alias = current.alias ? { [`-${current.alias}`]: name } : {};
        return Object.assign({}, pre, {
            [name]: current.type,
        }, alias);
    }, {});
};
exports.optionsToKeyValue = optionsToKeyValue;
const removeHyphen = (key) => {
    return key.replace(/^[-]+/, '');
};
exports.removeHyphen = removeHyphen;
